%global commit          5a6d6a2acaad299791beb4283fa7ff67ca0d9531
%global snapshotdate    20180727
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global extraver        beta6

Name:           ravada
Version:        0.3.0
Release:        0.6.%{extraver}%{?dist}
Summary:        Remote Virtual Desktops Manager
# AGPLv3: main program
# ASL 2.0: public/css/sb-admin.css
#          public/js/main.js
License:        AGPLv3 and ASL 2.0
URL:            https://ravada.upc.edu/
# Source0:        https://github.com/UPC/ravada/archive/%%{version}/%%{name}-%%{version}.tar.gz
Source0:        https://github.com/UPC/ravada/archive/%{commit}/%{name}-%{version}-%{extraver}.tar.gz

Patch0:         0001-Make-compatible-with-Perl-5.16.patch

BuildArch:      noarch
%{?systemd_requires}
BuildRequires:  systemd
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Authen::Passphrase)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(DBD::SQLite)
BuildRequires:  perl(DBIx::Connector)
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(feature)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(Hash::Util)
BuildRequires:  perl(HTTP::Request)
BuildRequires:  perl(Image::Magick)
BuildRequires:  perl(IO::Interface)
BuildRequires:  perl(IPC::Run3)
BuildRequires:  perl(IPTables::ChainMgr)
BuildRequires:  perl(JSON::XS)
BuildRequires:  perl(lib)
BuildRequires:  perl(Locale::Maketext::Lexicon)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(Mojolicious) >= 6.15
BuildRequires:  perl(Mojolicious::Plugin::I18N)
BuildRequires:  perl(Mojolicious::Plugin::RenderFile)
BuildRequires:  perl(Moose)
BuildRequires:  perl(MooseX::Types::NetAddr::IP)
BuildRequires:  perl(Net::DNS)
BuildRequires:  perl(Net::LDAP)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(strict)
BuildRequires:  perl(Sys::Statistics::Linux)
BuildRequires:  perl(Sys::Virt)
# BuildRequires:  perl(Test::Moose::More)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Test::Pod::Coverage)
BuildRequires:  perl(Test::Perl::Critic)
BuildRequires:  perl(Test::SQL::Data)
BuildRequires:  perl(Time::Piece)
BuildRequires:  perl(vars)
BuildRequires:  perl(warnings)
BuildRequires:  perl(XML::LibXML)
BuildRequires:  perl(YAML)
# For tests
BuildRequires:  iptables
BuildRequires:  ImageMagick
BuildRequires:  libvirt
BuildRequires:  mariadb-server
BuildRequires:  qemu-img
BuildRequires:  wget
Requires:       perl(Mojolicious::Plugin::I18N)
Requires:       perl(Mojolicious::Plugin::RenderFile)
Requires:       iptables
Requires:       libvirt
Requires:       mariadb-server
Requires:       qemu-img
Requires:       qemu-kvm
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires(pre):  shadow-utils
Requires:       virt-viewer

%description
Ravada is a software that allows the user to connect to a remote virtual 
desktop.

In the current release we use the KVM Hypervisors: KVM as the backend for the 
Virtual Machines. LXC support is currently in development.


%prep
%autosetup -p1 -n %{name}-%{commit}

# Fedora doesn't ship kvm-spice but qemu-kvm
find . -type f -name "*.xml" -exec sed -i 's|/usr/bin/kvm-spice|/usr/libexec/qemu-kvm|g' {} ';'

# Remove vmport instruction which is not supported on EPEL qemu
find . -type f -name "*.xml" -exec sed -i "/vmport/d" {} ';'

#Fix SQL directory
sed -i 's|"/usr/share/doc/ravada/sql/mysql"|"/usr/share/doc/ravada-%{version}/sql/mysql"|' lib/Ravada.pm


%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%make_build


%install
make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} $RPM_BUILD_ROOT/*

rm $RPM_BUILD_ROOT%{perl_vendorlib}/rvd_front.pl
install -Dpm 0755 rvd_front.pl $RPM_BUILD_ROOT%{_sbindir}/rvd_front
install -Dpm 0755 bin/rvd_back.pl  $RPM_BUILD_ROOT%{_sbindir}/rvd_back
install -Dpm 0755 bin/benchmark_create.pl  $RPM_BUILD_ROOT%{_sbindir}/rvd_benchmark_create
install -Dpm 0644 etc/ravada.conf $RPM_BUILD_ROOT%{_sysconfdir}/ravada.conf
install -Dpm 0644 etc/rvd_front.conf.example $RPM_BUILD_ROOT%{_sysconfdir}/rvd_front.conf
install -Dpm 0644 etc/systemd/rvd_back.service $RPM_BUILD_ROOT%{_unitdir}/rvd_back.service
install -Dpm 0644 etc/systemd/rvd_front.service $RPM_BUILD_ROOT%{_unitdir}/rvd_front.service
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}
cp -aR etc/xml $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -aR public $RPM_BUILD_ROOT%{_datadir}/%{name}/
cp -aR templates $RPM_BUILD_ROOT%{_datadir}/%{name}/

# Fix shebang
# F28 does this automatically, remove when F27 is eol
sed -i '1s/env //' $RPM_BUILD_ROOT%{_sbindir}/rvd_back
sed -i '1s/env //' $RPM_BUILD_ROOT%{_sbindir}/rvd_benchmark_create
sed -i '1s/env //' $RPM_BUILD_ROOT%{_sbindir}/rvd_front

# Remove empty files
find $RPM_BUILD_ROOT -size 0 -delete


%check
# silently ignore errors
make test || :


%pre
getent group ravada >/dev/null || groupadd -r ravada
getent passwd ravada >/dev/null || \
    useradd -r -g ravada -d %{_localstatedir}/lib/ravada -s /sbin/nologin \
    -c "Ravada user account" ravada
exit 0


%post
%systemd_post rvd_back.service
%systemd_post rvd_front.service


%preun
%systemd_preun rvd_back.service
%systemd_preun rvd_front.service


%postun
%systemd_postun_with_restart rvd_back.service
%systemd_postun_with_restart rvd_front.service


%files
%doc CHANGELOG.md CODE_OF_CONDUCT.md CONTRIBUTING.md README.md sql
%license LICENSE
%{_sbindir}/rvd_back
%{_sbindir}/rvd_benchmark_create
%{_sbindir}/rvd_front
%{perl_vendorlib}/*
%config(noreplace) %{_sysconfdir}/*.conf
%{_datadir}/%{name}/
%{_localstatedir}/lib/%{name}/
%{_mandir}/man3/*
%{_unitdir}/*.service


%changelog
* Tue Aug 07 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.6.beta6
- Remove vmport in templates, which is not supported in EPEL qemu

* Sun Aug 05 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.5.beta6
- Fix qemu-kvm path for EPEL

* Sat Aug 04 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.4.beta6
- Fix _unique_uuid call

* Thu Aug 02 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.3.beta6
- Fix SQL for MariaDB 5.5

* Wed Aug 01 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.2.beta6
- Add a patch for compatibility with Perl 5.16

* Fri Jul 27 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-0.1.beta6
- Pre-release 0.3.0 beta6

* Tue Jun 05 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.17-1
- Release 0.2.17

* Fri Jun 01 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.16-1
- Release 0.2.16

* Thu May 10 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.15-1
- Release 0.2.15

* Mon Mar 19 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.14-1
- Release 0.2.14

* Wed Feb 28 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.13-2
- Fix incorrect kvm binary

* Wed Feb 28 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.13-1
- Release 0.2.13
- Fix rvd_back/rvd_front installation

* Tue Feb  6 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.13-0.1.20180117gitf70dfbf
- Pre-release 0.2.13

* Tue Jan 16 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.12-1
- Upstream release 0.2.12

* Mon Dec 04 2017 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.10-1
- Specfile autogenerated by cpanspec 1.78.
